/*
 * main2.c
 *
 *  Created on: Oct 21, 2016
 *      Author: wn
 */

/*
 * 1. insert #include "main2.h" at USER CODE Includes of main.c
 * 2. insert my_setup_1(); at USER CODE 1 in main.c
 * 3. insert my_setup_2(); at USER CODE 2 in main.c
 * 4. insert my_loop(); at USER CODE 3 in main.c
 */



#include <stdlib.h>
#include <PontCoopScheduler.h>
#include "stm32f1xx_hal.h"


extern TIM_HandleTypeDef htim1;
extern TIM_HandleTypeDef htim2;


void blink(void *handle) {
	HAL_GPIO_TogglePin(LED_PIN_GPIO_Port, LED_PIN_Pin);

}

void my_setup_1() {
	schInit();
	schAdd(blink, NULL, 0, 100);
}

void my_setup_2() {
	  HAL_TIM_OC_Start_IT(&htim1, TIM_CHANNEL_1);
	  HAL_TIM_OC_Start_IT(&htim1, TIM_CHANNEL_2);
	  HAL_TIM_OC_Start_IT(&htim1, TIM_CHANNEL_3);

	  HAL_TIM_OC_Start(&htim2, TIM_CHANNEL_1);
	  HAL_TIM_OC_Start(&htim2, TIM_CHANNEL_2);
	  HAL_TIM_OC_Start(&htim2, TIM_CHANNEL_3);

	  HAL_NVIC_SetPriority(TIM1_CC_IRQn, 0, 0);
	  HAL_NVIC_EnableIRQ(TIM1_CC_IRQn);
}

void my_loop() {
	schExec();
}


void HAL_SYSTICK_Callback() {
	//HAL_GPIO_TogglePin(LED_PIN_GPIO_Port, LED_PIN_Pin);
	schUpdate();
}

void HAL_TIM_OC_DelayElapsedCallback(TIM_HandleTypeDef * htim) {
	if (htim->Instance == TIM1) {
		if (htim->Channel == HAL_TIM_ACTIVE_CHANNEL_1) {
			HAL_GPIO_TogglePin(LED2_PIN_GPIO_Port, LED2_PIN_Pin);
		} else if (htim->Channel == HAL_TIM_ACTIVE_CHANNEL_2) {
			HAL_GPIO_TogglePin(LED3_PIN_GPIO_Port, LED3_PIN_Pin);
		} else if (htim->Channel == HAL_TIM_ACTIVE_CHANNEL_3) {
			HAL_GPIO_TogglePin(LED4_PIN_GPIO_Port, LED4_PIN_Pin);
		}
	}
}
